; Fraktale-Welt: V. Ossenkopf 2000
; Routines for mountain plots

; Definition of a color table useful for the mountain landscape
pro makecolortable

colorb=[140,200,235,255,100, 70, 50, 30,  0, 50, 50, 50, 50,140,225,255]
colorg=[  0, 70,100,140,140,140,170,190,235,255,170,170,170,140,225,255]
colorr=[  0, 30, 30, 30, 20, 20, 20, 20, 20,100,150,190,220,140,225,255]
ncolb=bytarr(256)
ncolg=bytarr(256)
ncolr=bytarr(256)

for i=0,15 do begin
  for j=0,15 do begin
    ncolb[16*j+i]=byte(colorb[j]*float(i)/15.0)
    ncolg[16*j+i]=byte(colorg[j]*float(i)/15.0)
    ncolr[16*j+i]=byte(colorr[j]*float(i)/15.0)
  endfor
endfor

tvlct, ncolr, ncolg, ncolb

return
end

; Create mountain plot by superposition of two different
; shading approaches
pro gebirge, feld, level=level, size=size

if not keyword_set(size) then size=256
if not keyword_set(level) then level=1.0
if level ge 1.9 then level=1.9

; Reduce under water scaling
lim=1.0-level/2.0
mul=0.33333*level/(2.0-level)
low=lim-mul*lim

mmin=min(feld)
delta=max(feld)-mmin
indices=where(feld lt mmin+lim*delta)
feld[indices]=mmin+low*delta+(feld[indices]-mmin)*mul

mmin=min(feld)
delta=max(feld)-mmin
farben=byte((feld-mmin)*255/delta)
; Set sea level
indices=where(feld lt mmin+0.32*delta)
feld[indices]=mmin+0.32*delta

set_plot, "PS"
shade_surf, feld, xstyle=4,ystyle=4,zstyle=4, /upper_only, $
        pixels=size, image=light
shade_surf, feld, shades=farben,xstyle=4,ystyle=4,zstyle=4, $
        /upper_only, pixels=size, image=height
set_plot, "X"

makecolortable
newimage=byte(height/16)*16B+byte(light/16)
tv, newimage,0,size/10

return
end

