; Fraktale-Welt: V. Ossenkopf 2000
; Routines for MIDI file output

;  Create the default header for the WAV file
function waveheader, length

allhd=byte('RIFF')
allcnt=byte('WAVE')
fmthd=byte('fmt ')
fmtlength=byte(16L,0,4)
fmtcnt=[byte(1,0,2),byte(1,0,2),byte('5622'XL,0,4),byte('5622'XL,0,4),$
        byte(1,0,2),byte(8,0,2)]
dthd=byte('data')

length=long(length)
dtlength=byte(length,0,4)
alllength=byte(length+36L,0,4)

array=[allhd,alllength,allcnt,fmthd,fmtlength,fmtcnt,dthd,dtlength]

return, array
end

; Transform the data field into WAV format
function wavfield, field, scal=scal

if not keyword_set(scal) then scal=1.0
; Normalize
mmin=min(field)
mmax=max(field)
bfield=byte((field-mmin)*192.0*scal/(mmax-mmin)+32.0)
return, bfield
end

; General WAV caller routine
pro wavefile, name, field, scal=scal

feld=wavfield(field,scal=scal)
length=n_elements(feld)
array=[waveheader(length),feld]

get_lun, lun
openw, lun, name
writeu, lun, array
free_lun, lun

return
end

